namespace phat {

class ex {};

/// @see Best Table Bable
class Test
{
public:
    bool methodA( bool param ) const;
    bool methodB( bool param ) const throw ( ex );
    bool methodC( bool param ) const throw ();
    bool methodD( bool param ) const throw ();
    bool methodE( bool param ) const;
    bool methodF() const throw ();
    bool methodG( bool param ) const throw ();
};

bool Test::methodA( bool param ) const
{
    return param;
}

bool Test::methodB( bool param ) const throw ( ex )
{
    return methodA( param );
}

bool Test::methodC( bool param ) const throw ()
{
    return methodB( param );
}

bool Test::methodD( bool param ) const throw ()
{
    if ( param == methodA( param ) ) return methodB( param );
    return methodC( param );
}

bool Test::methodE( bool param ) const
{
    return methodD( param );
}

bool Test::methodF() const throw ()
{
    return methodD( false );
}

bool Test::methodG( bool param ) const throw ()
{
    return methodD( param );
}


/// @see Bable Table Test
class Best
{
public:
    int methodA( int param ) const;
    int methodB( int param ) const throw ( ex );
    int methodC( int param ) const throw ();
    int methodD( int param ) const throw ();
    int methodE( int param ) const;
    int methodF() const throw ();
    int methodG( int param ) const throw ();
};

int Best::methodA( int param ) const
{
    return param;
}

int Best::methodB( int param ) const throw ( ex )
{
    return methodA( param );
}

int Best::methodC( int param ) const throw ()
{
    return methodB( param );
}

int Best::methodD( int param ) const throw ()
{
    if ( param == methodA( param ) ) return methodB( param );
    return methodC( param );
}

int Best::methodE( int param ) const
{
    return methodD( param );
}

int Best::methodF() const throw ()
{
    return methodD( false );
}

int Best::methodG( int param ) const throw ()
{
    return methodD( param );
}


/// @see Test Best Table
class Bable {
public:
    int callA() const throw () { return 0; }
    int callB( int param ) const throw () { return param; }
    bool test1( int column ) const throw ();
    bool test2( int column ) throw ();
    bool test3( int column ) const;
    bool test4() const throw ();
    bool test5( int column ) const throw ( ex );
    bool test6( int column ) const throw ( ex );
    bool test62( int column ) const throw ( ex );
    void testAll1() throw ();
    void testAll2( int param ) throw ();
    bool methodA( bool param ) const;
    bool methodB( bool param ) const throw ( ex );
    bool methodC( bool param ) const throw ();
    bool methodD( bool param ) const throw ();
    bool methodE( bool param ) const;
    bool methodF() const throw ();
    bool methodG( bool param ) const throw ();
};

bool Bable::test1( int column ) const throw ()
{
    if ( column < 0 ) throw ex();
    if ( column >= callA() ) throw ex();
    if ( column >= callB( column ) ) throw ex();
}

bool Bable::test2( int column ) throw ()
{
    if ( column < 0 ) throw ex();
    if ( column >= callA() ) throw ex();
    if ( column >= callB( column ) ) throw ex();
}

bool Bable::test3( int column ) const
{
    if ( column < 0 ) throw ex();
    if ( column >= callA() ) throw ex();
    if ( column >= callB( column ) ) throw ex();
}

bool Bable::test4() const throw ()
{
    int column = 0;
    if ( column < 0 ) throw ex();
    if ( column >= callA() ) throw ex();
    if ( column >= callB( column ) ) throw ex();
}

bool Bable::test5( int column ) const throw ( ex )
{
    if ( column < 0 ) throw ex();
    if ( column >= callA() ) throw ex();
    if ( column >= callB( column ) ) throw ex();
}

bool Bable::test6( int column ) const throw ( ex )
{
    if ( column < 0 ) throw ex();
    if ( column >= callA() ) throw ex();
    if ( column >= callB( column ) ) throw ex();
}

bool Bable::test62( int column ) const throw ( ex )
{
    return test6( column );
}

void Bable::testAll1() throw ()
{
    test1( 0 );
    test2( 0 );
    test3( 0 );
    test4();
    test5( 0 );
    test6( 0 );
    test62( 0 );
}

void Bable::testAll2( int param ) throw ()
{
    test1( param );
    test2( param );
    test3( param );
    test4();
    test5( param );
    test6( param );
    test62( param );
}

bool Bable::methodA( bool param ) const
{
    return param;
}

bool Bable::methodB( bool param ) const throw ( ex )
{
    return methodA( param );
}

bool Bable::methodC( bool param ) const throw ()
{
    return methodB( param );
}

bool Bable::methodD( bool param ) const throw ()
{
    if ( param == methodA( param ) ) return methodB( param );
    return methodC( param );
}

bool Bable::methodE( bool param ) const
{
    return methodD( param );
}

bool Bable::methodF() const throw ()
{
    return methodD( false );
}

bool Bable::methodG( bool param ) const throw ()
{
    return methodD( param );
}


/// @see Best Test Bable
class Table {
public:
    int callA() const throw () { return 0; }
    int callB( int param ) const throw () { return param; }
    bool test1( int column ) const throw ();
    bool test2( int column ) throw ();
    bool test3( int column ) const;
    bool test4() const throw ();
    bool test5( int column ) const throw ( ex );
    bool test6( int column ) const throw ( ex );
    bool test62( int column ) const throw ( ex );
    void testAll1() throw ();
    void testAll2( int param ) throw ();
    bool methodA( bool param ) const;
    bool methodB( bool param ) const throw ( ex );
    bool methodC( bool param ) const throw ();
    bool methodD( bool param ) const throw ();
    bool methodE( bool param ) const;
    bool methodF() const throw ();
    bool methodG( bool param ) const throw ();
};

bool Table::test1( int column ) const throw ()
{
    if ( column < 0 ) throw ex();
    if ( column >= callA() ) throw ex();
    if ( column >= callB( column ) ) throw ex();
}

bool Table::test2( int column ) throw ()
{
    if ( column < 0 ) throw ex();
    if ( column >= callA() ) throw ex();
    if ( column >= callB( column ) ) throw ex();
}

bool Table::test3( int column ) const
{
    if ( column < 0 ) throw ex();
    if ( column >= callA() ) throw ex();
    if ( column >= callB( column ) ) throw ex();
}

bool Table::test4() const throw ()
{
    int column = 0;
    if ( column < 0 ) throw ex();
    if ( column >= callA() ) throw ex();
    if ( column >= callB( column ) ) throw ex();
}

bool Table::test5( int column ) const throw ( ex )
{
    if ( column < 0 ) throw ex();
    if ( column >= callA() ) throw ex();
    if ( column >= callB( column ) ) throw ex();
}

bool Table::test6( int column ) const throw ( ex )
{
    if ( column < 0 ) throw ex();
    if ( column >= callA() ) throw ex();
    if ( column >= callB( column ) ) throw ex();
}

bool Table::test62( int column ) const throw ( ex )
{
    return test6( column );
}

void Table::testAll1() throw ()
{
    test1( 0 );
    test2( 0 );
    test3( 0 );
    test4();
    test5( 0 );
    test6( 0 );
    test62( 0 );
}

void Table::testAll2( int param ) throw ()
{
    test1( param );
    test2( param );
    test3( param );
    test4();
    test5( param );
    test6( param );
    test62( param );
}

bool Table::methodA( bool param ) const
{
    return param;
}

bool Table::methodB( bool param ) const throw ( ex )
{
    return methodA( param );
}

bool Table::methodC( bool param ) const throw ()
{
    return methodB( param );
}

bool Table::methodD( bool param ) const throw ()
{
    if ( param == methodA( param ) ) return methodB( param );
    return methodC( param );
}

bool Table::methodE( bool param ) const
{
    return methodD( param );
}

bool Table::methodF() const throw ()
{
    return methodD( false );
}

bool Table::methodG( bool param ) const throw ()
{
    return methodD( param );
}

}

